## ubuntu-purchase-service 14.04%2B14.04.20140310.2ubuntu2

=== src/tests/CMakeLists.txt ===
set(XVFB_CMD xvfb-run -a -s "-screen 0 640x480x24")
add_custom_target (qmlunit-tests
  COMMAND env QML2_IMPORT_PATH=${CMAKE_CURRENT_BINARY_DIR}/.. ${XVFB_CMD} qmltestrunner -input ${CMAKE_CURRENT_SOURCE_DIR}/qml
  DEPENDS ${QML_PLUGIN_NAME}
)

find_package(Qt5Core REQUIRED)

set (PURCHASE_TESTS_TARGET test-purchase-service)

add_definitions(-DTESTS)
add_executable(${PURCHASE_TESTS_TARGET}
    test_ubuntupurchase.cpp
    ../ubuntupurchase.cpp
    ../purchase_service_client.cpp
    ../purchase_service_adaptor.cpp
    ../purchaseclient.cpp
    ../purchase_service.cpp
    fakessoservice.cpp
    fakedbus.cpp
)
target_link_libraries(${PURCHASE_TESTS_TARGET} ${UBUNTUONE_LDFLAGS})
qt5_use_modules(${PURCHASE_TESTS_TARGET} Qml Quick Core DBus Xml Network Test)

add_custom_target (cppunit-tests
  COMMAND ${XVFB_CMD} ${CMAKE_CURRENT_BINARY_DIR}/${PURCHASE_TESTS_TARGET}
  DEPENDS ${PURCHASE_TESTS_TARGET}
)

## ubuntu-purchase-service 14.04+14.04.20140310.2ubuntu2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.9)

# This is the name and release version of the project
PROJECT (ubuntu-purchase-service)

# The QML mmodule information
set (QML_MODULE_NAME Ubuntu.Purchase)
set (QML_MODULE_PATH Ubuntu/Purchase)
set (QML_PLUGIN_NAME UbuntuPurchase)
set (QML_PLUGIN_API_VERSION 0.1)

# Install the qml file from here.
install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/qml/${QML_PLUGIN_NAME}.qml
  DESTINATION lib/${PROJECT_NAME}
)

# Need to get libsignon/accounts here, as they get exposed in headers
find_package (PkgConfig REQUIRED)
pkg_check_modules(UBUNTUONE REQUIRED ubuntuoneauth-2.0)
add_definitions(${UBUNTUONE_CFLAGS} ${UBUNTUONE_CFLAGS_OTHER})

# Some default CFLAGS
SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -g -Wall -Werror -fPIC")
SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -O2 -g -Wall -Werror -fPIC")

# Allow specifying the libdir to use for the C library
SET (LIB_SUFFIX "" CACHE STRING "Define suffix of library directory name.")
SET (LIB_INSTALL_DIR "lib${LIB_SUFFIX}")

set (QML_MODULE_INSTALL_DIR ${LIB_INSTALL_DIR}/qt5/qml )

# We need to add these here which simply depend on other test rules, as
# CMake doesn't allow defining a "check" rule in multiple places.
# We use $namespace-tests[-valgrind[-leaks]] for the test names in subdirs,
# and depend on them here, so that 'make check' will run them all.
add_custom_target (check
  DEPENDS qmlunit-tests cppunit-tests
)

add_subdirectory (src)

=== src/CMakeLists.txt ===
# Qt5 bits
set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)
find_package(Qt5Core REQUIRED)

set (PSA_SOURCES purchase_service_adaptor.cpp purchase_service_adaptor.h)
set (PSC_SOURCES purchase_service_client.cpp purchase_service_client.h)
file (GLOB CPP_SOURCES *.cpp)

configure_file (qmldir.in qmldir)

add_library (${QML_PLUGIN_NAME} MODULE
  ${CPP_SOURCES} ${PSA_SOURCES} ${PSC_SOURCES})
qt5_use_modules (${QML_PLUGIN_NAME} Core Widgets Quick Qml )
target_link_libraries (${QML_PLUGIN_NAME}
  ${UBUNTUONE_LDFLAGS}
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/qmldir
  DESTINATION ${QML_MODULE_INSTALL_DIR}/${QML_MODULE_PATH}
)

set (SERVICE_FILE com.canonical.Purchase.service)
add_custom_command (TARGET ${QML_PLUGIN_NAME} POST_BUILD
  COMMAND sed -e "s#\@PKGLIBDIR\@#${CMAKE_INSTALL_PREFIX}/lib/${PROJECT_NAME}#g" < ${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_FILE}.in > ${SERVICE_FILE}
)

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${SERVICE_FILE}
  DESTINATION share/dbus-1/services/
)

install (PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/ubuntu-purchase-service
  DESTINATION lib/${PROJECT_NAME}
)

install (TARGETS ${QML_PLUGIN_NAME}
  LIBRARY DESTINATION ${QML_MODULE_INSTALL_DIR}/${QML_MODULE_PATH}
  NAMELINK_SKIP
)

install (CODE "execute_process(COMMAND qmlplugindump ${QML_MODULE_NAME} ${QML_PLUGIN_API_VERSION} ${CMAKE_INSTALL_PREFIX}/${QML_MODULE_INSTALL_DIR} OUTPUT_FILE ${CMAKE_INSTALL_PREFIX}/${QML_MODULE_INSTALL_DIR}/${QML_MODULE_PATH}/${QML_PLUGIN_NAME}.qmltypes)")

# These targets are here for convenience purposes, so we can generate the
# source code if the XML ever changes. They must be run by hand, and the
# results committed to bzr, if any changes are made to the XML file.
set (SERVICE_XML_FILE com.canonical.Purchase.xml)
add_custom_target (gen-dbus-source
  DEPENDS gen-dbus-proxy gen-dbus-adaptor
)
add_custom_target (gen-dbus-proxy
  COMMAND qdbusxml2cpp -c PurchaseServiceClient -p purchase_service_client ${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_XML_FILE}
  SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_XML_FILE}
)
add_custom_target (gen-dbus-adaptor
  COMMAND qdbusxml2cpp -c PurchaseServiceAdaptor -a purchase_service_adaptor ${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_XML_FILE}
  SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${SERVICE_XML_FILE}
)

# Create a directory and symlink so the component can be loaded by the tests
add_custom_command (TARGET ${QML_PLUGIN_NAME} POST_BUILD
  COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/Ubuntu && ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/${QML_MODULE_PATH}
)

# Add the generated files to be cleaned, as well as the symlink
set_property (
  DIRECTORY .
  PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
  ${SERVICE_FILE}
  Ubuntu
  qmldir
)

add_subdirectory (tests)

=== debian/changelog ===
ubuntu-purchase-service (14.04+14.04.20140310.2ubuntu2) trusty; urgency=medium

  * No-change rebuild for shlib changes in qtbase and qtdeclarative.

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Mon, 14 Apr 2014 17:31:52 -0300

ubuntu-purchase-service (14.04+14.04.20140310.2ubuntu1) trusty; urgency=medium

  * No-change rebuild against QtWebkit 5.1.

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Thu, 13 Mar 2014 23:24:25 -0300

ubuntu-purchase-service (14.04+14.04.20140310.2) trusty; urgency=low

  [ CI bot ]
  * No change rebuild against Qt 5.2.1.

  [ Rodney Dawes ]
  * Use 'env' to set the environment for qml unit tests. Add build/
    directory to the ignore list. (LP: #1273570)

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 10 Mar 2014 09:46:19 +0000

ubuntu-purchase-service (14.04+14.04.20140114.4) trusty; urgency=low

  [ Robert Bruce Park ]
  * `wrap-and-sort -a -s -t`.
  * Packaging fixes requested by didrocks.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 14

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Tue, 14 Jan 2014 18:43:00 +0000

ubuntu-purchase-service (14.04+14.04.20140113) trusty; urgency=low

  [ Diego Sarmentero ]
  * Fix Dbus activation typo. Fix environment variables detection.
    Adding c++ tests for the UbuntuPurchase plugin. (LP: #1267906,
    #1267907)

  [ Rodney Dawes ]
  * Package the purchase service.
  * Add some checklist items for submitting and reviewing branches, to
    HACKING.
  * Use wrap-and-sort -a -s -t to appease daily release packaging
    guidelines. Clean up last few main issues from last branch. .

  [ Robert Bruce Park ]
  * Minor fixes as per daily_release guidelines.

  [ Ubuntu daily release ]
  * Automatic snapshot from revision 11

 -- Ubuntu daily release <ps-jenkins@lists.canonical.com>  Mon, 13 Jan 2014 18:03:29 +0000

ubuntu-purchase-service (14.04+14.04.20131219) trusty; urgency=low

  * Automatic snapshot from revision 5 (bootstrap)
  * Initial packaging. (LP: #1260471)

 -- Rodney Dawes <rodney.dawes@ubuntu.com>  Thu, 19 Dec 2013 17:29:05 -0500

=== debian/control ===
Source: ubuntu-purchase-service
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper (>= 9),
 libqt5webkit5-qmlwebkitplugin,
 libubuntuoneauth-2.0-dev,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtdeclarative5-dev-tools,
 qtdeclarative5-test-plugin,
 qtdeclarative5-ubuntu-ui-toolkit-plugin,
 xvfb,
Maintainer: Ubuntu One Developers <ubuntuone-users@lists.launchpad.net>
Standards-Version: 3.9.5
Vcs-Bzr: lp:ubuntu-purchase-service
Xs-Testsuite: autopkgtest

Package: ubuntu-purchase-service
Architecture: any
Multi-Arch: same
Pre-Depends:
 multiarch-support,
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ubuntu Purchase Service
 A service for enabling purchase of click package applications which are
 sold through the click app store.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=qt5
export DPKG_GENSYMBOLS_CHECK_LEVEL=4
DH_CMAKE_BUILD_DIR=obj-${DEB_BUILD_GNU_TYPE}
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH ?= $(shell dpk-architecture -qDEB_HOST_ARCH)


%:
	dh $@ --buildsystem cmake --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)

=== debian/tests/control ===
Tests: run-tests
Restrictions: rw-build-tree build-needed allow-stderr
Depends: @,
 cmake,
 debhelper (>= 9),
 libubuntuoneauth-2.0-dev,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtdeclarative5-ubuntu-ui-toolkit-plugin,
 xvfb
